<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: instruments.proto

namespace Tinkoff\Invest\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 *Информация о выплате.
 *
 * Generated from protobuf message <code>tinkoff.public.invest.api.contract.v1.Dividend</code>
 */
class Dividend extends \Google\Protobuf\Internal\Message
{
    /**
     *Величина дивиденда на 1 ценную бумагу (включая валюту).
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue dividend_net = 1;</code>
     */
    protected $dividend_net = null;
    /**
     *Дата фактических выплат.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp payment_date = 2;</code>
     */
    protected $payment_date = null;
    /**
     *Дата объявления дивидендов.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp declared_date = 3;</code>
     */
    protected $declared_date = null;
    /**
     *Последний день (включительно) покупки для получения выплаты.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp last_buy_date = 4;</code>
     */
    protected $last_buy_date = null;
    /**
     *Тип выплаты. Возможные значения: Regular Cash – регулярные выплаты, Cancelled – выплата отменена, Daily Accrual – ежедневное начисление, Return of Capital – возврат капитала, прочие типы выплат.
     *
     * Generated from protobuf field <code>string dividend_type = 5;</code>
     */
    protected $dividend_type = '';
    /**
     *Дата фиксации реестра
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp record_date = 6;</code>
     */
    protected $record_date = null;
    /**
     *Регулярность выплаты. Возможные значения: Annual – ежегодная, Semi-Anl – каждые полгода, прочие типы выплат.
     *
     * Generated from protobuf field <code>string regularity = 7;</code>
     */
    protected $regularity = '';
    /**
     *Цена закрытия инструмента на момент ex_dividend_date.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue close_price = 8;</code>
     */
    protected $close_price = null;
    /**
     *Величина доходности.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Quotation yield_value = 9;</code>
     */
    protected $yield_value = null;
    /**
     *Дата и время создания записи.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp created_at = 10;</code>
     */
    protected $created_at = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Tinkoff\Invest\V1\MoneyValue $dividend_net
     *          Величина дивиденда на 1 ценную бумагу (включая валюту).
     *     @type \Google\Protobuf\Timestamp $payment_date
     *          Дата фактических выплат.
     *     @type \Google\Protobuf\Timestamp $declared_date
     *          Дата объявления дивидендов.
     *     @type \Google\Protobuf\Timestamp $last_buy_date
     *          Последний день (включительно) покупки для получения выплаты.
     *     @type string $dividend_type
     *          Тип выплаты. Возможные значения: Regular Cash – регулярные выплаты, Cancelled – выплата отменена, Daily Accrual – ежедневное начисление, Return of Capital – возврат капитала, прочие типы выплат.
     *     @type \Google\Protobuf\Timestamp $record_date
     *          Дата фиксации реестра
     *     @type string $regularity
     *          Регулярность выплаты. Возможные значения: Annual – ежегодная, Semi-Anl – каждые полгода, прочие типы выплат.
     *     @type \Tinkoff\Invest\V1\MoneyValue $close_price
     *          Цена закрытия инструмента на момент ex_dividend_date.
     *     @type \Tinkoff\Invest\V1\Quotation $yield_value
     *          Величина доходности.
     *     @type \Google\Protobuf\Timestamp $created_at
     *          Дата и время создания записи.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Instruments::initOnce();
        parent::__construct($data);
    }

    /**
     *Величина дивиденда на 1 ценную бумагу (включая валюту).
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue dividend_net = 1;</code>
     * @return \Tinkoff\Invest\V1\MoneyValue
     */
    public function getDividendNet()
    {
        return $this->dividend_net;
    }

    /**
     *Величина дивиденда на 1 ценную бумагу (включая валюту).
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue dividend_net = 1;</code>
     * @param \Tinkoff\Invest\V1\MoneyValue $var
     * @return $this
     */
    public function setDividendNet($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\MoneyValue::class);
        $this->dividend_net = $var;

        return $this;
    }

    /**
     *Дата фактических выплат.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp payment_date = 2;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getPaymentDate()
    {
        return $this->payment_date;
    }

    /**
     *Дата фактических выплат.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp payment_date = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setPaymentDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->payment_date = $var;

        return $this;
    }

    /**
     *Дата объявления дивидендов.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp declared_date = 3;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getDeclaredDate()
    {
        return $this->declared_date;
    }

    /**
     *Дата объявления дивидендов.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp declared_date = 3;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setDeclaredDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->declared_date = $var;

        return $this;
    }

    /**
     *Последний день (включительно) покупки для получения выплаты.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp last_buy_date = 4;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getLastBuyDate()
    {
        return $this->last_buy_date;
    }

    /**
     *Последний день (включительно) покупки для получения выплаты.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp last_buy_date = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setLastBuyDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->last_buy_date = $var;

        return $this;
    }

    /**
     *Тип выплаты. Возможные значения: Regular Cash – регулярные выплаты, Cancelled – выплата отменена, Daily Accrual – ежедневное начисление, Return of Capital – возврат капитала, прочие типы выплат.
     *
     * Generated from protobuf field <code>string dividend_type = 5;</code>
     * @return string
     */
    public function getDividendType()
    {
        return $this->dividend_type;
    }

    /**
     *Тип выплаты. Возможные значения: Regular Cash – регулярные выплаты, Cancelled – выплата отменена, Daily Accrual – ежедневное начисление, Return of Capital – возврат капитала, прочие типы выплат.
     *
     * Generated from protobuf field <code>string dividend_type = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setDividendType($var)
    {
        GPBUtil::checkString($var, True);
        $this->dividend_type = $var;

        return $this;
    }

    /**
     *Дата фиксации реестра
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp record_date = 6;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getRecordDate()
    {
        return $this->record_date;
    }

    /**
     *Дата фиксации реестра
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp record_date = 6;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setRecordDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->record_date = $var;

        return $this;
    }

    /**
     *Регулярность выплаты. Возможные значения: Annual – ежегодная, Semi-Anl – каждые полгода, прочие типы выплат.
     *
     * Generated from protobuf field <code>string regularity = 7;</code>
     * @return string
     */
    public function getRegularity()
    {
        return $this->regularity;
    }

    /**
     *Регулярность выплаты. Возможные значения: Annual – ежегодная, Semi-Anl – каждые полгода, прочие типы выплат.
     *
     * Generated from protobuf field <code>string regularity = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setRegularity($var)
    {
        GPBUtil::checkString($var, True);
        $this->regularity = $var;

        return $this;
    }

    /**
     *Цена закрытия инструмента на момент ex_dividend_date.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue close_price = 8;</code>
     * @return \Tinkoff\Invest\V1\MoneyValue
     */
    public function getClosePrice()
    {
        return $this->close_price;
    }

    /**
     *Цена закрытия инструмента на момент ex_dividend_date.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.MoneyValue close_price = 8;</code>
     * @param \Tinkoff\Invest\V1\MoneyValue $var
     * @return $this
     */
    public function setClosePrice($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\MoneyValue::class);
        $this->close_price = $var;

        return $this;
    }

    /**
     *Величина доходности.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Quotation yield_value = 9;</code>
     * @return \Tinkoff\Invest\V1\Quotation
     */
    public function getYieldValue()
    {
        return $this->yield_value;
    }

    /**
     *Величина доходности.
     *
     * Generated from protobuf field <code>.tinkoff.public.invest.api.contract.v1.Quotation yield_value = 9;</code>
     * @param \Tinkoff\Invest\V1\Quotation $var
     * @return $this
     */
    public function setYieldValue($var)
    {
        GPBUtil::checkMessage($var, \Tinkoff\Invest\V1\Quotation::class);
        $this->yield_value = $var;

        return $this;
    }

    /**
     *Дата и время создания записи.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp created_at = 10;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getCreatedAt()
    {
        return $this->created_at;
    }

    /**
     *Дата и время создания записи.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp created_at = 10;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setCreatedAt($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->created_at = $var;

        return $this;
    }

}

